> For the complete documentation index, see [llms.txt](https://docs.console.zenlayer.com/api-reference/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.console.zenlayer.com/api-reference/compute/zec/cidr-block/createbyoip.md).

# CreateByoip

## 1. API Description

This API (CreateByoip) is used to Create a BYOIP CIDR block . Returns the list of RPKI/IRR validation failures.

## 2. Input Parameters

The following request parameter list only provides API request parameters.

| Parameter Name  | Required | Type                                                                                    | Description                                                                                                                                                                                       |
| --------------- | -------- | --------------------------------------------------------------------------------------- | ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------- |
| byoipList       | Yes      | Array of [ByoipCreateItem](/api-reference/compute/zec/datastructure.md#byoipcreateitem) | The list of BYOIPs to be created.                                                                                                                                                                 |
| marketingInfo   | No       | [MarketingInfo](/api-reference/compute/zec/datastructure.md#marketinginfo)              | Information on marketing campaigns.                                                                                                                                                               |
| resourceGroupId | No       | String                                                                                  | <p>The ID of the resource group where the BYOIP CIDR block will reside after creation.</p><p>If the value is not passed in, the BYOIP CIDR block will be put into the default resource group.</p> |
| tags            | No       | [TagAssociation](/api-reference/compute/zec/datastructure.md#tagassociation)            | <p>Tags associated when creating resources.</p><p>Note: The associated <code>tag key</code> cannot be duplicated.</p>                                                                             |

## 3. Output Parameters

| Parameter Name | Type            | Description                                                                                                           |
| -------------- | --------------- | --------------------------------------------------------------------------------------------------------------------- |
| requestId      | String          | <p>The unique request ID, which is returned for each request.</p><p>RequestId is required for locating a problem.</p> |
| rpkiFailedList | Array of String | List of CIDR blocks that failed RPKI validation.                                                                      |
| irrFailedList  | Array of String | List of CIDR blocks that failed IRR validation.                                                                       |
| byoipIds       | Array of String | ID list of created BYOIP CIDR blocks.                                                                                 |

## 4. Code Example

{% tabs %}
{% tab title="Example" %}
**Create a BYOIP CIDR block.**

```json
POST /api/v2/zec HTTP/1.1
Host: console.zenlayer.com
Content-Type: application/json
X-ZC-Action: CreateByoIp
<Common Request Params>

Request：
{
  "byoIpList": [
    {
      "cidrBlock": "88.0.2.0/24",
      "networkType": "PremiumBGP",
      "regionId": "asia-east-1",
      "asn": 62610
    }
  ]
}

Response：
{
  "requestId": "TBFC01FCF-6439-4530-ADBC-16809F0C3E8F",
  "response": {
    "requestId": "TBFC01FCF-6439-4530-ADBC-16809F0C3E8F",
    "rpkiFailedList": [],
    "irrFailedList": [],
    "byoipIds":["<byoIpId1>"]
  }
}
```

{% endtab %}
{% endtabs %}

## 5. Developer Resources

Zenlayer Cloud API 2.0 integrates [SDKs](/api-reference/api-introduction/toolkit/api-sdk.md)，to make it easier for you to call APIs. More programming languages will be supported.

## 6. Error Codes

The following only lists the error codes related to the API business logic. For other error codes, see [Common Error Codes](/api-reference/api-introduction/instruction/commonerrorcode.md).

| HTTP Status Code | Error Code                                         | Description                                                                                  |
| ---------------- | -------------------------------------------------- | -------------------------------------------------------------------------------------------- |
| 400              | INVALID\_BYOIP\_ASN\_INVALID                       | Invalid BYOIP ASN number.                                                                    |
| 400              | INVALID\_BYOIP\_DUPLICATE                          | BYOIP is duplicated.                                                                         |
| 400              | INVALID\_BYOIP\_IS\_ALREADY\_EXIST                 | BYOIP already exists.                                                                        |
| 400              | INVALID\_CIDR\_ADDRESS                             | Invalid IP address.                                                                          |
| 400              | INVALID\_CIDR\_FORMAT                              | The specified CIDR block format error.                                                       |
| 400              | INVALID\_IPV6\_CIDR\_RANGE                         | The CIDR range is invalid.                                                                   |
| 400              | INVALID\_IPV6\_SUBNET\_MASK\_LENGTH                | IPv6 subnet mask length is out of valid range.                                               |
| 404              | INVALID\_REGION\_NOT\_FOUND                        | Specified availability zone does not exist.                                                  |
| 400              | OPERATION\_DENIED\_EIP\_UNSUPPORTED\_NETWORK\_TYPE | The EIP network billing method is not supported.                                             |
| 400              | OPERATION\_DENIED\_NOT\_SUPPORT\_BYOIP\_SELF       | The selected BYOIP network type does not support self-advertisement in the specified region. |


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.console.zenlayer.com/api-reference/compute/zec/cidr-block/createbyoip.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
